﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;



       //////////////////////////////////////////////////////////////////////////////////////////
       //                      "به نام خداوند بخشنده و مهربان"                              //
       //////////////////////////////////////////////////////////////////////////////////////////


namespace _2mench
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {

        #region "Program Requirements"
        GoalFinder gf = new GoalFinder();
        Boolean yourTurn = false, CPU = true, fin=false;
        int bra;
        //dicenum=>Dice Number & DNC=>Rotation Number & DRA=>Rotation Angle
        public static int dicenum, DNC = 0, DRA = 0;
        //nn=>Rotation period
        public static int nn = 0;
        //To Make Known >> Red And Blue ProgressBar
        public ProgressBar p = new ProgressBar();
        //To Make Known >> Red And Blue Dice
        public Image d = new Image();
        System.Windows.Threading.DispatcherTimer RotateDiceTimer = new System.Windows.Threading.DispatcherTimer()
        , PowTimer = new System.Windows.Threading.DispatcherTimer()
        , cpuTimer = new System.Windows.Threading.DispatcherTimer();
        #endregion

        public MainWindow()
        {
            InitializeComponent();
            RotateDiceTimer.Tick += new EventHandler(RotateDiceTimer_Tick);
            PowTimer.Tick += new EventHandler(PowTimer_Tick);
            cpuTimer.Tick += new EventHandler(cpuTimer_Tick);
            RotateDiceTimer.Interval = TimeSpan.FromMilliseconds(30);
            PowTimer.Interval = TimeSpan.FromMilliseconds(10);
        }
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            B1.IsEnabled = B2.IsEnabled = B3.IsEnabled = B4.IsEnabled = false;
            R1.IsEnabled = R2.IsEnabled = R3.IsEnabled = R4.IsEnabled = false;
            RedDice.IsEnabled = BlueDice.IsEnabled = false;
            RedDice.Visibility = BlueDice.Visibility = Visibility.Hidden;
            R1.Visibility = R2.Visibility = R3.Visibility = R4.Visibility = B1.Visibility = B2.Visibility =
                        B3.Visibility = B4.Visibility = Visibility.Hidden;
        }
        void start()
        {
            #region "Start New Game"
            fin = false;
            changeTurn(false);
            RedDice.IsEnabled = BlueDice.IsEnabled = true;
            R1.Visibility = R2.Visibility = R3.Visibility = R4.Visibility = B1.Visibility = B2.Visibility =
                        B3.Visibility = B4.Visibility = Visibility.Visible;
            RotateDiceTimer.IsEnabled = false;
            DNC = nn = 0;
            if (CPU == true)
            {
                BlueDice.IsEnabled = false;
            }

            //GOALS=NULL(-1)  .....................................................................
            gf.REDGOAL[0] = gf.REDGOAL[1] = gf.REDGOAL[2] = gf.REDGOAL[3]
                = gf.BLUEGOAL[0] = gf.BLUEGOAL[1] = gf.BLUEGOAL[2] = gf.BLUEGOAL[3] = -1;
            //.....................................................................................

            #region "مرتب کردن مهره ها"
            Image[] Rmen = new Image[4] { R1, R2, R3, R4 }, Bmen = new Image[4] { B1, B2, B3, B4 };
            for (int j = 0; j <= 3; j++)
            {
                canvas1.Children.Remove(Rmen[j]);
                Canvas.SetLeft(Rmen[j], Players.PlayerRed[j, 0]);
                Canvas.SetTop(Rmen[j], Players.PlayerRed[j, 1]);
                canvas1.Children.Add(Rmen[j]);
                gf.REDMEN[j] = j;
                canvas1.Children.Remove(Bmen[j]);
                Canvas.SetLeft(Bmen[j], Players.PlayerBlue[j, 0]);
                Canvas.SetTop(Bmen[j], Players.PlayerBlue[j, 1]);
                canvas1.Children.Add(Bmen[j]);
                gf.BLUEMEN[j] = j;
            }
            #endregion
            #endregion
        }
        void changeTurn(Boolean yTurn)
        {
            #region "تغيير بازيکن"
            for (int i = 0; i == 0; i++)
            {
                if (yTurn == true)
                    yourTurn = false;
                else
                    yourTurn = true;
            }
            if (yourTurn == true)
            {
                RedDice.IsEnabled = true;
                RedDice.LayoutTransform = new RotateTransform(0);
                if (fin==false)
                {
                    RedDice.Visibility = Visibility.Visible;
                    BlueDice.Visibility = Visibility.Hidden;
                }
                Uri src1 = new Uri(@"/2mench;component/Images/turnMenuYT.png", UriKind.Relative);
                BitmapImage img1 = new BitmapImage(src1);
                image2.Source = img1;
                Uri src3 = new Uri(@"/2mench;component/Images/click.png", UriKind.Relative);
                BitmapImage img3 = new BitmapImage(src3);
                d.Source = img3;
                B1.IsEnabled = B2.IsEnabled = B3.IsEnabled = B4.IsEnabled = false;
                R1.IsEnabled = R2.IsEnabled = R3.IsEnabled = R4.IsEnabled = true;
            }
            else if (yourTurn == false)
            {
                BlueDice.IsEnabled = true;
                BlueDice.LayoutTransform = new RotateTransform(0);
                if (fin==false)
                {
                    BlueDice.Visibility = Visibility.Visible;
                    RedDice.Visibility = Visibility.Hidden;
                }
                Uri src1 = new Uri(@"/2mench;component/Images/turnMenuMT.png", UriKind.Relative);
                BitmapImage img1 = new BitmapImage(src1);
                image2.Source = img1;
                Uri src3 = new Uri(@"/2mench;component/Images/click.png", UriKind.Relative);
                BitmapImage img3 = new BitmapImage(src3);
                d.Source = img3;
                B1.IsEnabled = B2.IsEnabled = B3.IsEnabled = B4.IsEnabled = true;
                R1.IsEnabled = R2.IsEnabled = R3.IsEnabled = R4.IsEnabled = false;
                if (CPU == true)
                {
                    Random r = new Random();
                    DiceImg_MouseDown(BlueDice, null);
                    cpuTimer.Interval = TimeSpan.FromMilliseconds(r.Next(10, 1000));
                    cpuTimer.IsEnabled = true;
                }

            }
            #endregion
        }
        void cpuTimer_Tick(object sender, EventArgs e)
        {
            BluePow_MouseUp(BluePow, null);
            cpuTimer.IsEnabled = false;
        }
        
        void RotateDiceTimer_Tick(object sender, EventArgs e)
        {
            #region "چرخيدن تاس"
            DNC++;
            DiceNumber();
            DiceImage(dicenum);
            DRA += 25;
            d.IsEnabled = false;
            d.LayoutTransform = new RotateTransform(DRA);
            if (DNC == nn)
            {
                RotateDiceTimer.IsEnabled = false;
                DNC = nn = DRA = 0;
                if (yourTurn == false)
                    gf.BGoals(dicenum);
                else
                    gf.RGoals(dicenum);
                #region Useless Dice
                if (yourTurn == true)
                {
                    if (dicenum != 6 & (gf.REDGOAL[0] + gf.REDGOAL[1] + gf.REDGOAL[2] + gf.REDGOAL[3]) == -4)
                        changeTurn(yourTurn);
                    else if (dicenum == 6 & (gf.REDGOAL[0] + gf.REDGOAL[1] + gf.REDGOAL[2] + gf.REDGOAL[3]) == -4)
                        RedDice.IsEnabled = true;
                }
                else
                {
                    if (dicenum != 6 & (gf.BLUEGOAL[0] + gf.BLUEGOAL[1] + gf.BLUEGOAL[2] + gf.BLUEGOAL[3]) == -4)
                        changeTurn(yourTurn);
                    else if (dicenum == 6 & (gf.BLUEGOAL[0] + gf.BLUEGOAL[1] + gf.BLUEGOAL[2] + gf.BLUEGOAL[3]) == -4)
                        BlueDice.IsEnabled = true;
                    else if (CPU == true)
                        cpuAgent();
                }
                #endregion

            }
            #endregion
        }
        void cpuAgent()
        {
            #region "دسترسی سی پی يو به کنترل ها"
            CPU _cpu = new CPU();
            _cpu.cpu();
            switch (_cpu.SelectedMAN)
            {
                case 0:
                    Men_MouseLeftButtonDown(B1, null);
                    break;
                case 1:
                    Men_MouseLeftButtonDown(B2, null);
                    break;
                case 2:
                    Men_MouseLeftButtonDown(B3, null);
                    break;
                case 3:
                    Men_MouseLeftButtonDown(B4, null);
                    break;
            }
            if (yourTurn == false)
            {
                Random r = new Random();
                DiceImg_MouseDown(BlueDice, null);
                cpuTimer.Interval = TimeSpan.FromMilliseconds(r.Next(10, 1000));
                cpuTimer.IsEnabled = true;
            }
            #endregion
        }
        //Dice Number
        void DiceNumber()
        {
            Random ran = new Random();
            dicenum = ran.Next(1, 7);
        }
        //Set The Image Of Dice
        void DiceImage(int Dn)
        {
            switch (Dn)
            {
                case 1:
                    Uri src1 = new Uri(@"/2mench;component/Images/No1.png", UriKind.Relative);
                    BitmapImage img1 = new BitmapImage(src1);
                    d.Source = img1;
                    break;
                case 2:
                    Uri src2 = new Uri(@"/2mench;component/Images/No2.png", UriKind.Relative);
                    BitmapImage img2 = new BitmapImage(src2);
                    d.Source = img2;
                    break;
                case 3:
                    Uri src3 = new Uri(@"/2mench;component/Images/No3.png", UriKind.Relative);
                    BitmapImage img3 = new BitmapImage(src3);
                    d.Source = img3;
                    break;
                case 4:
                    Uri src4 = new Uri(@"/2mench;component/Images/No4.png", UriKind.Relative);
                    BitmapImage img4 = new BitmapImage(src4);
                    d.Source = img4;
                    break;
                case 5:
                    Uri src5 = new Uri(@"/2mench;component/Images/No5.png", UriKind.Relative);
                    BitmapImage img5 = new BitmapImage(src5);
                    d.Source = img5;
                    break;
                case 6:
                    Uri src6 = new Uri(@"/2mench;component/Images/No6.png", UriKind.Relative);
                    BitmapImage img6 = new BitmapImage(src6);
                    d.Source = img6;
                    break;
            }
        }

        private void DiceImg_MouseDown(object sender, MouseButtonEventArgs e)
        {
            Image dic = (Image)sender;
            d = dic;
            d.IsEnabled = false;
            dic.Visibility = Visibility.Hidden;
            if (dic == RedDice)
            {
                RedPow.IsEnabled = true;
                RedPow.Visibility = Visibility.Visible;
                p = RedPow;
                PowTimer.IsEnabled = true;
                nn = 0;
            }
            else if (dic == BlueDice)
            {
                BluePow.IsEnabled = true;
                BluePow.Visibility = Visibility.Visible;
                p = BluePow;
                PowTimer.IsEnabled = true;
                nn = 0;
            }

        }
        //set ProgressBar Value
        private void PowTimer_Tick(object sender, EventArgs e)
        {
            nn++;
            if (nn <= 100)
                p.Value = nn;
            else
                PowTimer.IsEnabled = false;
        }

        private void BluePow_MouseUp(object sender, MouseButtonEventArgs e)
        {
            PowTimer.IsEnabled = false;
            ProgressBar dice = (ProgressBar)sender;
            dice.Visibility = Visibility.Hidden;
            if (dice == RedPow)
            {
                RedDice.Visibility = Visibility.Visible;
                RotateDiceTimer.IsEnabled = true;
            }
            else if (dice == BluePow)
            {
                BlueDice.Visibility = Visibility.Visible;
                RotateDiceTimer.IsEnabled = true;
            }
            dice.IsEnabled = false;
        }

        private void BluePow_MouseLeave(object sender, MouseEventArgs e)
        {
            PowTimer.IsEnabled = false;
            ProgressBar dice = (ProgressBar)sender;
            dice.Visibility = Visibility.Hidden;
            if (dice == RedPow)
            {
                RedDice.Visibility = Visibility.Visible;
                p = null;
                RedDice.IsEnabled = true;
            }
            else if (dice == BluePow)
            {
                BlueDice.Visibility = Visibility.Visible;
                p = null;
                BlueDice.IsEnabled = true;
            }
            dice.IsEnabled = true;
        }



        private void btnStartG_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            btnStartGWC.Visibility = btnStartGWF.Visibility = Visibility.Visible;
        }

        private void Window_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.Key == Key.Escape)
            {
                if (btnStartGWF.Visibility == Visibility.Visible)
                    btnStartGWC.Visibility = btnStartGWF.Visibility = Visibility.Hidden;

            }
        }

        private void btnStart_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            UserControl btnstart = (UserControl)sender;
            //>VS Computer>
            if (sender == btnStartGWC)
            {
                CPU = true;
                lblNameRed.Content = "بازیکن 1";
                lblNameBlue.Content = "کامپیوتر";
            }
            //>VS Human>
            else if (sender == btnStartGWF)
            {
                CPU = false;
                lblNameRed.Content = "بازیکن 1";
                lblNameBlue.Content = "بازیکن 2";
            }
            start();
            btnStartGWC.Visibility = btnStartGWF.Visibility = Visibility.Hidden;

        }

        int EqualMen(object sender)
        {
            Image imgh = (Image)sender;
            switch (imgh.Name)
            {
                case "R1":
                    bra = 0;
                    return gf.REDGOAL[0];
                    break;
                case "R2":
                    bra = 1;
                    return gf.REDGOAL[1];
                    break;
                case "R3":
                    bra = 2;
                    return gf.REDGOAL[2];

                    break;
                case "R4":
                    bra = 3;
                    return gf.REDGOAL[3];

                    break;
                case "B1":
                    bra = 0;
                    return gf.BLUEGOAL[0];

                    break;
                case "B2":
                    bra = 1;
                    return gf.BLUEGOAL[1];

                    break;
                case "B3":
                    bra = 2;
                    return gf.BLUEGOAL[2];

                    break;
                default:
                    bra = 3;
                    return gf.BLUEGOAL[3];
                    break;
            }
        }
        private void Men_MouseEnter(object sender, MouseEventArgs e)
        {
            if (yourTurn == true & Convert.ToInt32(EqualMen(sender)) != -1)
            {
                Canvas.SetLeft(image, Players.PlayerRed[Convert.ToInt32(EqualMen(sender)), 0]);
                Canvas.SetTop(image, Players.PlayerRed[Convert.ToInt32(EqualMen(sender)), 1]);
                image.Visibility = Visibility.Visible;
            }
            else if (Convert.ToInt32(EqualMen(sender)) != -1)
            {
                Canvas.SetLeft(image, Players.PlayerBlue[Convert.ToInt32(EqualMen(sender)), 0]);
                Canvas.SetTop(image, Players.PlayerBlue[Convert.ToInt32(EqualMen(sender)), 1]);
                image.Visibility = Visibility.Visible;
            }
            canvas1.Children.Remove(image);
            canvas1.Children.Add(image);

        }

        private void Men_MouseLeave(object sender, MouseEventArgs e)
        {
            image.Visibility = Visibility.Hidden;
        }

        private void Men_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            Image Man = (Image)sender;
            if (yourTurn == true & Convert.ToInt32(EqualMen(sender)) != -1)
            {
                Canvas.SetLeft(Man, Players.PlayerRed[Convert.ToInt32(EqualMen(sender)), 0]);
                Canvas.SetTop(Man, Players.PlayerRed[Convert.ToInt32(EqualMen(sender)), 1]);
                canvas1.Children.Remove(Man);
                canvas1.Children.Add(Man);

                for (int i = 0; i == 0; i++)
                {

                    gf.REDMEN[bra] = Convert.ToInt32(EqualMen(sender));

                }
                if (gf.REDMEN[0] + gf.REDMEN[1] + gf.REDMEN[2] + gf.REDMEN[3] == 118)
                {
                    fin = true;
                    MessageBox.Show(lblNameRed.Content + "برنده شد.");
                    RedDice.IsEnabled = BlueDice.IsEnabled = false;
                    RedDice.Visibility = BlueDice.Visibility = Visibility.Hidden;
                    R1.Visibility = R2.Visibility = R3.Visibility = R4.Visibility = B1.Visibility = B2.Visibility =
                        B3.Visibility = B4.Visibility = Visibility.Hidden;
                    RotateDiceTimer.IsEnabled = false;
                    CPU = false;
                }
                for (int l = 0; l <= 3; l++)
                {
                    //اگر مهره قرمز در محل مهره آبی قرار بگيرد
                    if (Players.PlayerRed[Convert.ToInt32(EqualMen(sender)), 0] == Players.PlayerBlue[gf.BLUEMEN[l], 0]
                        & Players.PlayerRed[Convert.ToInt32(EqualMen(sender)), 1] == Players.PlayerBlue[gf.BLUEMEN[l], 1])
                    {
                        for (int j = 0, h = 0; j <= 3; j++, h = 0)
                        {
                            for (int k = 0; k <= 3; k++)
                                if (j != gf.BLUEMEN[k])
                                    h++;
                            if (h == 4)
                            {
                                switch (l)
                                {
                                    case 0:
                                        canvas1.Children.Remove(B1);
                                        Canvas.SetLeft(B1, Players.PlayerBlue[j, 0]);
                                        Canvas.SetTop(B1, Players.PlayerBlue[j, 1]);
                                        canvas1.Children.Add(B1);
                                        break;
                                    case 1:
                                        canvas1.Children.Remove(B2);
                                        Canvas.SetLeft(B2, Players.PlayerBlue[j, 0]);
                                        Canvas.SetTop(B2, Players.PlayerBlue[j, 1]);
                                        canvas1.Children.Add(B2);
                                        break;
                                    case 2:
                                        canvas1.Children.Remove(B3);
                                        Canvas.SetLeft(B3, Players.PlayerBlue[j, 0]);
                                        Canvas.SetTop(B3, Players.PlayerBlue[j, 1]);
                                        canvas1.Children.Add(B3);
                                        break;
                                    case 3:
                                        canvas1.Children.Remove(B4);
                                        Canvas.SetLeft(B4, Players.PlayerBlue[j, 0]);
                                        Canvas.SetTop(B4, Players.PlayerBlue[j, 1]);
                                        canvas1.Children.Add(B4);
                                        break;
                                }
                                gf.BLUEMEN[l] = j;
                            }

                        }
                    }
                }
                for (int i = 0; i <= 3; i++)
                {
                    gf.REDGOAL[i] = -1;

                }
                for (int i = 0; i == 0; i++)
                {
                    if (dicenum != 6)
                        changeTurn(yourTurn);
                    else
                        RedDice.IsEnabled = true;
                }
            }
            else if (Convert.ToInt32(EqualMen(sender)) != -1)
            {
                Canvas.SetLeft(Man, Players.PlayerBlue[Convert.ToInt32(EqualMen(sender)), 0]);
                Canvas.SetTop(Man, Players.PlayerBlue[Convert.ToInt32(EqualMen(sender)), 1]);
                canvas1.Children.Remove(Man);
                canvas1.Children.Add(Man);

                for (int i = 0; i == 0; i++)
                {
                    gf.BLUEMEN[bra] = Convert.ToInt32(EqualMen(sender));
                }
                //win blue
                if (gf.BLUEMEN[0] + gf.BLUEMEN[1] + gf.BLUEMEN[2] + gf.BLUEMEN[3] == 118)
                {
                    fin = true;
                    MessageBox.Show(lblNameBlue.Content + "برنده شد.");
                    RedDice.IsEnabled = BlueDice.IsEnabled = false;
                    RedDice.Visibility = BlueDice.Visibility = Visibility.Hidden;
                    R1.Visibility = R2.Visibility = R3.Visibility = R4.Visibility = B1.Visibility = B2.Visibility =
                        B3.Visibility = B4.Visibility = Visibility.Hidden;
                    RotateDiceTimer.IsEnabled = false;
                    CPU = false;
                }
                for (int l = 0; l <= 3; l++)
                {
                    //اگر مهره آبی در محل مهره قرمز قرار بگيرد
                    if (Players.PlayerBlue[Convert.ToInt32(EqualMen(sender)), 0] == Players.PlayerRed[gf.REDMEN[l], 0]
                        & Players.PlayerBlue[Convert.ToInt32(EqualMen(sender)), 1] == Players.PlayerRed[gf.REDMEN[l], 1])
                    {
                        for (int j = 0, h = 0; j <= 3; j++, h = 0)
                        {
                            for (int k = 0; k <= 3; k++)
                                if (j != gf.REDMEN[k])
                                    h++;
                            if (h == 4)
                            {
                                switch (l)
                                {
                                    case 0:
                                        canvas1.Children.Remove(R1);
                                        Canvas.SetLeft(R1, Players.PlayerRed[j, 0]);
                                        Canvas.SetTop(R1, Players.PlayerRed[j, 1]);
                                        canvas1.Children.Add(R1);
                                        break;
                                    case 1:
                                        canvas1.Children.Remove(R2);
                                        Canvas.SetLeft(R2, Players.PlayerRed[j, 0]);
                                        Canvas.SetTop(R2, Players.PlayerRed[j, 1]);
                                        canvas1.Children.Add(R2);
                                        break;
                                    case 2:
                                        canvas1.Children.Remove(R3);
                                        Canvas.SetLeft(R3, Players.PlayerRed[j, 0]);
                                        Canvas.SetTop(R3, Players.PlayerRed[j, 1]);
                                        canvas1.Children.Add(R3);
                                        break;
                                    case 3:
                                        canvas1.Children.Remove(R4);
                                        Canvas.SetLeft(R4, Players.PlayerRed[j, 0]);
                                        Canvas.SetTop(R4, Players.PlayerRed[j, 1]);
                                        canvas1.Children.Add(R4);
                                        break;
                                }
                                gf.REDMEN[l] = j;
                            }

                        }
                    }
                }
                for (int i = 0; i <= 3; i++)
                {
                    gf.BLUEGOAL[i] = -1;
                }
                for (int i = 0; i == 0; i++)
                {
                    if (dicenum != 6)
                        changeTurn(yourTurn);
                    else
                        BlueDice.IsEnabled = true;
                }
            }

        }

        private void menuBtn1_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            MessageBox.Show("سازنده بازی: علی طالبی", "درباره بازی",MessageBoxButton.OK,MessageBoxImage.Asterisk,MessageBoxResult.OK,MessageBoxOptions.RightAlign);
        }

        private void menuBtn6_MouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            Close();
        }


        }
    }
    

